=begin
#ChannelShipper & Royal Mail Public API

#Import your orders, retrieve your orders and generate labels.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module RoyalMail
  class CreateOrderRequest
    attr_accessor :order_reference

    attr_accessor :recipient

    attr_accessor :sender

    attr_accessor :billing

    attr_accessor :packages

    attr_accessor :order_date

    attr_accessor :planned_despatch_date

    attr_accessor :special_instructions

    attr_accessor :subtotal

    attr_accessor :shipping_cost_charged

    attr_accessor :other_costs

    # Customs Duty Costs is only supported in DDP (Delivery Duty Paid) services
    attr_accessor :customs_duty_costs

    attr_accessor :total

    attr_accessor :currency_code

    attr_accessor :postage_details

    attr_accessor :tags

    attr_accessor :label

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'order_reference' => :'orderReference',
        :'recipient' => :'recipient',
        :'sender' => :'sender',
        :'billing' => :'billing',
        :'packages' => :'packages',
        :'order_date' => :'orderDate',
        :'planned_despatch_date' => :'plannedDespatchDate',
        :'special_instructions' => :'specialInstructions',
        :'subtotal' => :'subtotal',
        :'shipping_cost_charged' => :'shippingCostCharged',
        :'other_costs' => :'otherCosts',
        :'customs_duty_costs' => :'customsDutyCosts',
        :'total' => :'total',
        :'currency_code' => :'currencyCode',
        :'postage_details' => :'postageDetails',
        :'tags' => :'tags',
        :'label' => :'label'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'order_reference' => :'Object',
        :'recipient' => :'Object',
        :'sender' => :'Object',
        :'billing' => :'Object',
        :'packages' => :'Object',
        :'order_date' => :'Object',
        :'planned_despatch_date' => :'Object',
        :'special_instructions' => :'Object',
        :'subtotal' => :'Object',
        :'shipping_cost_charged' => :'Object',
        :'other_costs' => :'Object',
        :'customs_duty_costs' => :'Object',
        :'total' => :'Object',
        :'currency_code' => :'Object',
        :'postage_details' => :'Object',
        :'tags' => :'Object',
        :'label' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `RoyalMail::CreateOrderRequest` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `RoyalMail::CreateOrderRequest`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'order_reference')
        self.order_reference = attributes[:'order_reference']
      end

      if attributes.key?(:'recipient')
        self.recipient = attributes[:'recipient']
      end

      if attributes.key?(:'sender')
        self.sender = attributes[:'sender']
      end

      if attributes.key?(:'billing')
        self.billing = attributes[:'billing']
      end

      if attributes.key?(:'packages')
        if (value = attributes[:'packages']).is_a?(Array)
          self.packages = value
        end
      end

      if attributes.key?(:'order_date')
        self.order_date = attributes[:'order_date']
      end

      if attributes.key?(:'planned_despatch_date')
        self.planned_despatch_date = attributes[:'planned_despatch_date']
      end

      if attributes.key?(:'special_instructions')
        self.special_instructions = attributes[:'special_instructions']
      end

      if attributes.key?(:'subtotal')
        self.subtotal = attributes[:'subtotal']
      end

      if attributes.key?(:'shipping_cost_charged')
        self.shipping_cost_charged = attributes[:'shipping_cost_charged']
      end

      if attributes.key?(:'other_costs')
        self.other_costs = attributes[:'other_costs']
      end

      if attributes.key?(:'customs_duty_costs')
        self.customs_duty_costs = attributes[:'customs_duty_costs']
      end

      if attributes.key?(:'total')
        self.total = attributes[:'total']
      end

      if attributes.key?(:'currency_code')
        self.currency_code = attributes[:'currency_code']
      end

      if attributes.key?(:'postage_details')
        self.postage_details = attributes[:'postage_details']
      end

      if attributes.key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.key?(:'label')
        self.label = attributes[:'label']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @recipient.nil?
        invalid_properties.push('invalid value for "recipient", recipient cannot be nil.')
      end

      if @order_date.nil?
        invalid_properties.push('invalid value for "order_date", order_date cannot be nil.')
      end

      if @subtotal.nil?
        invalid_properties.push('invalid value for "subtotal", subtotal cannot be nil.')
      end

      if @shipping_cost_charged.nil?
        invalid_properties.push('invalid value for "shipping_cost_charged", shipping_cost_charged cannot be nil.')
      end

      if @total.nil?
        invalid_properties.push('invalid value for "total", total cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @recipient.nil?
      return false if @order_date.nil?
      return false if @subtotal.nil?
      return false if @shipping_cost_charged.nil?
      return false if @total.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          order_reference == o.order_reference &&
          recipient == o.recipient &&
          sender == o.sender &&
          billing == o.billing &&
          packages == o.packages &&
          order_date == o.order_date &&
          planned_despatch_date == o.planned_despatch_date &&
          special_instructions == o.special_instructions &&
          subtotal == o.subtotal &&
          shipping_cost_charged == o.shipping_cost_charged &&
          other_costs == o.other_costs &&
          customs_duty_costs == o.customs_duty_costs &&
          total == o.total &&
          currency_code == o.currency_code &&
          postage_details == o.postage_details &&
          tags == o.tags &&
          label == o.label
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [order_reference, recipient, sender, billing, packages, order_date, planned_despatch_date, special_instructions, subtotal, shipping_cost_charged, other_costs, customs_duty_costs, total, currency_code, postage_details, tags, label].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        RoyalMail.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
